//----------------------------------------------------------------------------
// MIRS0202 Logging/LCD-method object
//                based on Eri.Taguchi
//                mod.  by Hajime Wakabayashi
//
//                     ver 0.1alpha Jan. 22 2004
//                         0.2      Jan. 30 2004

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <string.h>
#include <unistd.h>

#include "log.h"



//Construction ---------------------------------------------------------------
Logger::Logger(void) {
	//Open LCD device
	fd  = open("/dev/lcd",O_RDWR);
	if(fd<0){
		fprintf(stderr,"Cannot Open /dev/lcd\n");
		exit(0);
	}
 	//Open log file (append mode)
	if(NULL == (fdl=fopen("./log.dat","a"))) {
		fprintf(stderr,"Cannot Open LOGDATA_PATH\n");
		exit(0);
	}
	buf = buffer;
    buf = "                ";
}

//Destruction ----------------------------------------------------------------
Logger::~Logger(void) {
	close(fd);
	fclose(fdl);

}

void Logger::LcdDisp(char *str,int length) {
	lcd[0] = 1000;
	if (length > 16) { length = 16; }
	
	
	//set position to 1st line
	  lcd[0] = 0x10;
	  ioctl(fd,LCD_ADD_SET,lcd);
	  read(fd,buffer,0x10);
	  usleep(16*40);
	//read 1st line char to buffer
	//clear LCD char
	  ioctl(fd,LCD_CLEAR);
	  usleep(1640);
	//set position to 1st line
	  write(fd,str,length);
	  usleep(40*length);
	//set position to 2nd line
	  lcd[0] = 0x40;
	  ioctl(fd,LCD_ADD_SET,lcd);
	//copy 1st line char to 2nd line
          write(fd,buffer,16);
}
// Send String to LCD --------------------------------------------------------
void Logger::LogWrite(char *str,int length) {
	work = time(&timer);    /* oߎԂ̎o */
	
	sec = work % 60;        /* bo */
	work -= sec;            /* b */
	work = work / 60;       /* ̒Pʂɕϊ */
	
	min = work % 60;        /* o */
	work -= min;            /*  */
	work = work / 60;       /* ̒Pʂɕϊ */
	
	hour = work % 24;       /* o */
	
	fprintf(fdl,"%02d:%02d:%02d: ", hour, min, sec);
	fprintf(fdl,"%s",str);
	fprintf(fdl,"\n");
}
//----------------------------------------------------------------------------
void Logger::LogLcd(char *str,int length) {
	LcdDisp(str,length);
	LogWrite(str,length);
}
