/*********************************************/
/*     LCD Device Driver Header Program      */
/*                                           */
/*                  developed by Eri.Taguchi */
/*                     ver 1.0  Nov. 14 2000 */
/*********************************************/

#include <linux/ioctl.h>
#include <time.h>

#define LCD_MAJOR 60
#define LEN 64
#define CODE1 0x80
#define CODE2 0xc0
#define LINECOUNT 1

#define LCD_PORT_SETUP 0x0100
#define LCD_PORT_RDWR 0x0102

#define LCD_IOC_MAGIC 'l'
#define LCD_CLEAR          _IO(LCD_IOC_MAGIC, 40)
#define LCD_ADD_ZERO       _IO(LCD_IOC_MAGIC,  41)
#define LCD_CURSOR_SHIFT   _IOW(LCD_IOC_MAGIC, 42, lcd_setcode)
#define LCD_ON_OFF         _IOW(LCD_IOC_MAGIC, 43, lcd_setcode)
#define LCD_LIST_OR_CURSOR _IOW(LCD_IOC_MAGIC, 44, lcd_setcode)
#define LCD_TWO_SET        _IO(LCD_IOC_MAGIC,  45)
#define LCD_ADD_SET        _IOW(LCD_IOC_MAGIC, 46, lcd_setcode)
#define LCD_BF_ADD         _IOR(LCD_IOC_MAGIC, 47, lcd_setcode)
#define LCD_HARDRESET      _IO(LCD_IOC_MAGIC,  48)
#define LCD_IOC_MAXNR 48
/*
extern int lcd_detect(unsigned int, unsigned int );
extern void lcd_module_set(int);
extern int lcd_module_search(void);
extern char *lcd_module_read(void);
extern int lcd_module_write(char *,int);
extern void lcd_module_release(unsigned int,unsigned int );
*/
class Logger {
private:
	int fd;
	FILE *fdl;
	char *buf,buffer[32];
	int lcd_setcode,lcd[2];
    time_t  timer, work, sec, min, hour;	

public:
	Logger(void);
	~Logger(void);
	void LogLcd(char *,int);
	void LogWrite(char *,int);
	void LcdDisp(char *,int);
};


