/* ------------------------------------------------------------------------
 MIRS0202 PWM-Encoder Module

                     From ATLMIRS Documents
                  Mod. by Akihisa Onoda
                          Yoshio Kajitani
                          Hajime Wakabayashi
                     ver 0.1alpha Feb. 1 2004
   ------------------------------------------------------------------------ */

/* Includes */
#include <linux/errno.h>
#include <asm/io.h>
#include <unistd.h>
#include <math.h>
#include <rtl.h>
#include <time.h>
#include <rtl_sched.h>
#include <rtl_fifo.h>

#include "pwm_module.h"

/* ------------------------------------------------------------------------ */
/* Variables */
static pthread_t tasks[1];
static int fflag = 0;

int fifo3 = 3;
int fifo4 = 4;
struct SpeedData pwm;
struct CountData count;

int pwm_data_l1 = 0, pwm_data_r1 = 0;
int pwm_data_l2 = 0, pwm_data_r2 = 0;
int v = 0, w=128 , x = 0, y=128 , j;  /* variable for the calculation */
int abs1, abs2;
int fas=0;
int asd;
int ret;
int err;
int tup;
int l_count_1=0,r_count_1=0;
int l_cnt_old=0,r_cnt_old=0;
int t_sa_old=0;
int flag=0;

/* Variable for New Mode */
int vl = 0;
int vr = 0;
int l_count_v=0,r_count_v=0;
int hlv = 0, hrv = 0;	/*total count*/
int hlx = 0, hrx = 0;	/*this count*/
int hld = 0, hrd =0;	/*duty raito*/
int hsax = 0, hsav =0;	/**/
int han = 0;				/*hankei*/
int hcase = 0;				/*aɑ΂ꍇ킯*/
double Lgoal = 0.0;
double Rgoal = 0.0;
double sasasa = 0.0;

/* ------------------------------------------------------------------------ */
/* Prototype */
void mStraight(int Mode);
void mStop(void);
void mReturn(void);
void mLR(void);
void mHankei(void);
void SendCount(void);

/* ------------------------------------------------------------------------ */
/* Main */
void *thread_code(void *t) {
	/* Loop */
	while(1) {
		/* Get Value from RT-FIFO */
		while((err = rtf_get(fifo4, &pwm, sizeof(pwm))) == sizeof(pwm)){
			if(pwm.Mode == MODE_BITYOUSEI){
					pwm_data_r2 -= pwm.LSpeed;
					pwm_data_l2 += pwm.RSpeed;
					pwm.Mode = MODE_STR;
			}else{
			pwm_data_l1 = pwm.LSpeed;
			pwm_data_r1 = pwm.RSpeed;
//			tup = pwm.Tup;
  			pwm_data_l2 = 0;
			pwm_data_r2 = 0;
			l_count_1 = 0;
			r_count_1 = 0;
			flag = 0;
			}
		}

		switch(pwm.Mode){
			case MODE_STR:
			case MODE_STOP:
				mStraight(pwm.Mode);
				break;
			case MODE_RETURN:
				mReturn();
				break;
			case MODE_LR:
				mLR();
				break;
			case MODE_HANKEI:
				mHankei();
				break;
			case MODE_DUTY:
				outw(pwm_data_l1, PWM_LEFT_WRITE);
				outw(pwm_data_r1, PWM_RIGHT_WRITE);
				break;
			default:
				break;
		}
		flag++;
		SendCount();
		/* Waiting ... */
		ret = pthread_wait_np();
	 }
	 return 0;
}

/* ------------------------------------------------------------------------ */
/* Go Straight Mode */
void mStraight(int Mode) {
	if(flag==0){
		v=pwm_data_l1;
		x=pwm_data_r1;
		
		vl = v;
		x = abs(x);
		if(v > 128 && v <= 255){
			vr = v - SAc;
		} else if(v <128 && v >= 0){
			vr = v + SAc;
		} else {
			vr = 128;
			vl = 128;
		}
	} else {
		sasasa = (double)(SAv * Kv + SAx * Kx);
		if(sasasa >= 6.0) sasasa = 5.0;
		if(sasasa <= -6.0) sasasa = -5.0;
			vl = vl - (int)sasasa;
			vr = vr + (int)sasasa;
		flag = 0;
	} 

	if(Mode == MODE_STOP) {
		if(v > 128){
			if((GOAL - l_count_1)<40) vl=128;
			else if((GOAL - l_count_1) < (l_count_v*8))
				vl = FRmin + (vl - FRmin) * 90 / 100;
			if((GOAL + r_count_1)<40) vr=128;
			else if((GOAL + r_count_1) < (- r_count_v*8))
				vr = FRmin - SAc + (vr - FRmin + SAc) * 90 / 100;
		}else{
			if((GOAL + l_count_1) < 40) vl=128;
			else if((GOAL + l_count_1) < (- l_count_v*8))
				vl = RRmin + (vl - RRmin) * 90 / 100;
			if((GOAL - r_count_1) < 40) vr=128;
			else if((GOAL - r_count_1) < (r_count_v*8))
				vr = RRmin + SAc + (vr - RRmin - SAc) * 90 / 100;
		}
	}

	if(vl > 255){
		vr = vr - (vl - 255);
		vl = 255;
	}
	if(vr > 255){
		vl = vl - (vr - 255);
		vr = 255;
	}
	if(vl < 0){
		vr = vr - vl;
		vl = 0;
	}
	if(vr < 0){
		vl = vl - vr;
		vr = 0;
	}
	outw(vl,PWM_LEFT_WRITE);
	outw(vr,PWM_RIGHT_WRITE);
}
/* ------------------------------------------------------------------------ */
/* Stop Mode */
void mStop(void) {
	v = pwm_data_l1 - pwm_data_l2;
	if(v > Vmin)
		w = Kpl * v + vshift;
	else if(v < -Vmin)
		w = Kpl * v - vshift;
	w = (w > 115) ? 115 : w;       
	w = (w < -115) ? -115 : w;     
	w = (w >= 0) ? (w + 128) : -w;
	x = pwm_data_r1 + pwm_data_r2;
	if(x > Vmin)
		y = Kpr * x + vshift;
	else if(x < -Vmin)
		y = Kpr * x - vshift;
	y = (y > 115) ? 115 : y;
	y = (y < -115) ? -115 : y;
	y = (y >= 0) ? (y + 128) : -y;

	abs1 = (v >= 0) ? v : -v;
	abs2 = (x >= 0) ? x : -x;

	if(abs1 <= Vmin && abs2 <= Vmin)
		count.br = 1;
	else
		count.br = 0;


	if(w > 0)
		j = 7;
	else
		j = -7;
	
	outw(w+j, PWM_LEFT_WRITE);
	outw(y, PWM_RIGHT_WRITE);
}
/* ------------------------------------------------------------------------ */
/* Return Mode */
void mReturn(void) {
	for(asd=1;asd<=30;asd++){
		w=v=pwm_data_l1/30*(31-asd);
		y=x=pwm_data_r1/30*(31-asd);
		outw(w, PWM_LEFT_WRITE);
		outw(y, PWM_RIGHT_WRITE);
	}
}
/* ------------------------------------------------------------------------ */
/* LR Mode */
void mLR(void) {
	if(flag==0){
			w=v=pwm_data_l1;
			y=x=pwm_data_r1;
	} else if((flag < 10 && flag > 0) || flag == 101) {
			w = v;
			y = x;
	} else {
	/*	if((SA/50) >= 3){
			v = w - 2;
			x = y + 2;
		}else if((SA/50) <= -3){
			v = w + 2;
			x = y - 2;
		}else{
			v = w - SA / 50;
			x = y + SA / 50;
		}*/
		if(SA >= 3){
			v = 229;
			x = 225;
		} else if(SA <= -3) {
			v = 230;
			x = 225;
		} else {
			v = w;
			x = y;
		}

		if(v > 255){
			x = x - (v - 255);
			v = 255;
		}
		if(x > 255){
			v = v - (x - 255);
			x = 255;
		}
		if(v < 0){
			x = x - v;
			v = 0;
		}
		if(x < 0){
			v = v - x;
			x = 0;
		}
		w = v;
		y = x;
		if(SA>-3 && SA < 3) flag = 100;
		else flag = 0;
	 }
	outw(w, PWM_LEFT_WRITE);
	outw(y, PWM_RIGHT_WRITE);
}
/* ------------------------------------------------------------------------ */
/* Hankei Mode */
void mHankei(void) {
	if(flag==0){
		han=pwm_data_l1;
		x=pwm_data_r1;
		if(han == 0){
			if(x >= 0){
				hld = KIHON;
				hrd = 255 - KIHON - SAc;
			}else{
				hld = 255 - KIHON;
				hrd = KIHON + SAc;
			}
			hcase = 0;
		}else if(han < VAL && han > 0){
			if(x >= 0){
				hld = KIHON;
				hrd = RRmin - (han - VAL)/(han + VAL)*(255 - KIHON - SAc - RRmin);
			}else{
				hld = 255 - KIHON;
				hrd = FRmin - (han - VAL)/(han + VAL)*(KIHON + SAc - FRmin);
			}
			hcase = 1;
		}else if(han > VAL){
			if(x >= 0){
				hld = FRmin + (han + VAL)/han*(KIHON - FRmin);
				hrd = FRmin + (han - VAL)/han*(KIHON + SAc - FRmin);
			}else{
				hld = RRmin + (han + VAL)*(255 - KIHON - RRmin)/han;
				hrd = RRmin + (han - VAL)*(255 - KIHON - SAc - RRmin)/han;
			}
			hcase = 2;
		}else if(han > -VAL && han < 0){
			if(x >= 0){
				hrd = KIHON + SAc;
				hld = RRmin - (han + VAL)/(han - VAL)*(255 - KIHON - RRmin);
			}else{
				hrd = 255 - KIHON - SAc;
				hld = FRmin - (han + VAL)/(han - VAL)*(KIHON - FRmin);
			}
			hcase = -1;
		}else if(han < -VAL){
			if(x >= 0){
				hrd = KIHON + SAc;
				hld = FRmin + (han + VAL)/(han - VAL)*(KIHON - FRmin);
			}else{
				hrd = 255 - KIHON - SAc;
				hld = RRmin + (han + VAL)/(han - VAL)*(255 - KIHON - RRmin);
			}
			hcase = -2;
		}else{
			hld = 128;
			hrd = 128;
			hcase = 999;
		}
	} else {
		switch(hcase){
			case 0:
				hsax = hlx + hrx;
				hsav = hlv + hrv;
				sasasa = (double)(hsav * Kv + hsax * Kx);
				if(sasasa >= 6.0) sasasa = 5.0;
				if(sasasa <= -6.0) sasasa = -5.0;
				hld = hld - (int)sasasa;
				hrd = hrd - (int)sasasa;
				if(x >= 0){
					if((HGOAL - hlx) < 200){
						hld=128;
					}else if((HGOAL - hlx) < (hlv*8))
						{ hld = FRmin + (hld - FRmin) * 90 / 100;}
					if((HGOAL + hrx) < 200){
						hrd=128;
					}else if((HGOAL + hrx) < (-hrv*8))
						{ hrd = RRmin - SAc - (hrd - RRmin + SAc) * 90 / 100;}
				}else{
					if((HGOAL - hlx) > 200){
						hld=128;
					}else if((HGOAL - hlx) > (hlv*8))
						{ hld = RRmin - (hld - RRmin) * 90 / 100;}
					if((HGOAL + hrx) > 200){
						hrd=128;
					}else if((HGOAL + hrx) > (-hrv*8))
						{ hrd = FRmin + SAc + (hrd - FRmin - SAc) * 90 / 100;}
				}
				break;
			case 1:
//				if(x >= 0 && (HGOAL - hlx) < 40 && (HGOAL + hrx) < 40){
//					hld=128;
//					hrd=128;
//				}else if(x <= 0 && (HGOAL - hlx) > -40 && (HGOAL + hrx) > -40){
//					hld=128;
//					hrd=128;
//				}else{
				hsax = hlx - (han + VAL)/(han - VAL)*hrx;
				hsav = hlv - (han + VAL)/(han - VAL)*hrv;
				sasasa = (double)(hsav * Kv + hsax * Kx);
				if(sasasa >= 6.0) sasasa = 5.0;
				if(sasasa <= -6.0) sasasa = -5.0;
				hld = hld - (int)sasasa;
				hrd = hrd - (int)sasasa;
//				}
				break;
			case 2:
				hsax = han * hlx / (han + VAL) - han * hrx / (han - VAL);
				hsav = han * hlv / (han + VAL) - han * hrv / (han - VAL);
				sasasa = (double)(hsav * Kv + hsax * Kx);
				if(sasasa >= 6.0) sasasa = 5.0;
				if(sasasa <= -6.0) sasasa = -5.0;
				hld = hld - (int)sasasa;
				hrd = hrd + (int)sasasa;
				
				if((OGOAL - hlx) < 250){
					hld=128;
				}else if((OGOAL - hlx) < (hlv*8))
					{ hld = FRmin + (hld - FRmin) * 90 / 100;}
				if((IGOAL - hrx) < 150){
					hrd=128;
				}else if((IGOAL - hrx) < (hrv*8))
					{ hrd = FRmin + SAc - (hrd - FRmin - SAc) * 90 / 100;}
				break;
			case -1:
				hsax = (han - VAL)/(han + VAL)*hlx - hrx;
				hsav = (han - VAL)/(han + VAL)*hlv - hrv;
				sasasa = (double)(hsav * Kv + hsax * Kx);
				if(sasasa >= 6.0) sasasa = 5.0;
				if(sasasa <= -6.0) sasasa = -5.0;
				hld = hld - (int)sasasa;
				hrd = hrd - (int)sasasa;
				break;
			case -2:
				hsax = han/(han + VAL)*hlx + han/(han - VAL)*hrx;
				hsav = han/(han + VAL)*hlv + han/(han - VAL)*hrv;
				sasasa = (double)(hsav * Kv + hsax * Kx);
				if(sasasa >= 6.0) sasasa = 5.0;
				if(sasasa <= -6.0) sasasa = -5.0;
				hld = hld - (int)sasasa;
				hrd = hrd + (int)sasasa;
				break;
			case 999:
				hsax = 0;
				hsav = 0;
				break;
			default:
				break;
		}
		flag = 0;
	} 
	if(hld > 255){
		hrd = hrd - (hld - 255);
		hld = 255;
	}
	if(hrd > 255){
		hld = hld - (hrd - 255);
		hrd = 255;
	}
	if(hld < 0){
		hrd = hrd - hld;
		hld = 0;
	}
	if(hrd < 0){
		hld = hld - hrd;
		hrd = 0;
	}
	outw(hrd, PWM_LEFT_WRITE);
	outw(hld, PWM_RIGHT_WRITE);
}
/* ------------------------------------------------------------------------ */
/* Send Count Value */
void SendCount(void) {
	count.LCount = inw(LEFT_COUNTER);
	outw(COUNTER_RESET, LEFT_COUNTER);
	count.RCount = inw(RIGHT_COUNTER);
	outw(COUNTER_RESET, RIGHT_COUNTER);
	if(((count.LCount >> 15) & 1) == 1)
		count.LCount = -1 * (0x10000 - count.LCount);
	pwm_data_l2 += count.LCount;  
	if(((count.RCount >> 15) & 1) == 1)
		count.RCount = -1 * (0x10000 - count.RCount);
	pwm_data_r2 += count.RCount;
	if(pwm.Mode == MODE_LR){
		count.LSum = w;
		count.RSum = y;
	}
	else{
		count.LSum = pwm_data_l2;
		count.RSum = pwm_data_r2;
	}
	l_count_1 = pwm_data_l2;
	r_count_1 = pwm_data_r2;
	l_count_v = count.LCount;
	r_count_v = count.RCount;
	hrx = pwm_data_l2;
	hlx = - pwm_data_r2;
	hrv = count.LCount;
	hlv = - count.RCount;
	rtf_put(fifo3, &count, sizeof(count));
}

/* ------------------------------------------------------------------------ */
/* Set Status (see PWM::Set() in lspwm.cpp) */
int my_handler(unsigned int fifo)
{
	struct Message msg;
	int err;

	while((err = rtf_get(COMMAND_FIFO, &msg, sizeof(msg))) == sizeof(msg)){
		rtf_put(msg.Task + TASK_CONTROL_FIFO_OFFSET, &msg, sizeof(msg));
		switch(msg.Command){
			case START_TASK:
				pthread_make_periodic_np(tasks[0], gethrtime(), (long long)(msg.Period * 1000));
				pthread_wakeup_np(tasks[0]);
				outw(128, PWM_LEFT_WRITE);
				outw(128, PWM_RIGHT_WRITE);
				outw(COUNTER_RESET, LEFT_COUNTER);
				outw(COUNTER_RESET, RIGHT_COUNTER);
				break;
			case STOP_TASK:	
				pthread_suspend_np(tasks[0]);
				outw(128, PWM_LEFT_WRITE);
				outw(128, PWM_RIGHT_WRITE);
				outw(COUNTER_RESET, LEFT_COUNTER);
				outw(COUNTER_RESET, RIGHT_COUNTER);
				break;
			case RESTART_TASK:
				pthread_wakeup_np(tasks[0]);
				outw(128, PWM_LEFT_WRITE);
				outw(128, PWM_RIGHT_WRITE);
				outw(COUNTER_RESET, LEFT_COUNTER);
				outw(COUNTER_RESET, RIGHT_COUNTER);
				break;
/*			case TUNE_SET:
				//pwm_data_l2 += msg.tR;
				//pwm_data_r2 -= msg.tL;
				break;*/
			default:
				return 0;
				break;
		}
	}
	if(err != 0){
		return -EINVAL;
	}
	return 0;
}

/* ------------------------------------------------------------------------ */
int init_module(void)
{
	pthread_attr_t attr;
	struct sched_param sched_param;
	int c[4];
	int ret;

	rtf_destroy(3);
	rtf_destroy(4);
	rtf_destroy(5);
	rtf_destroy(6);
	c[0] = rtf_create(3, 4000);
	c[1] = rtf_create(4, 4000);
	c[2] = rtf_create(5, 200);      /* input control channel */
	c[3] = rtf_create(6, 100);      /* input control channel */

	pthread_attr_init(&attr);
	sched_param.sched_priority = 5;
	pthread_attr_setschedparam(&attr, &sched_param);
	ret = pthread_create(&tasks[0], &attr, thread_code, (void *)2);
	pthread_setfp_np (tasks[0],1);
	fflag = 1;

	rtf_create_handler(5, &my_handler);
	return 0;
}

/* ------------------------------------------------------------------------ */

void cleanup_module(void)
{
	outw(128, PWM_LEFT_WRITE);
	outw(128, PWM_RIGHT_WRITE);
#ifdef DEBUG
	rtl_printf("%d\n", rtf_destroy(3));
	rtl_printf("%d\n", rtf_destroy(4));
	rtl_printf("%d\n", rtf_destroy(5));
	rtl_printf("%d\n", rtf_destroy(6));
#else
	rtf_destroy(3);
	rtf_destroy(4); 
	rtf_destroy(5);
	rtf_destroy(6);
#endif
	if(fflag == 1){
	pthread_delete_np (tasks[0]);
	}
}

