/* PWM-Encoder Module C Header */

#ifndef _PWM_ENCODER_MOUDLE_H_
#define _PWM_ENCODER_MOUDLE_H_
	
#define TASK_CONTROL_FIFO_OFFSET  4
#define COUNTER_RESET  1

#define Vmin    16 
#define Vmin2	32
#define vshift  60 
#define Kpl    0.01
#define Kpr    0.01
#define FORWARD 1111
#define LEFT    2222
#define RIGHT   3333
#define BACK    4444
#define NONE    5555
#define WFm    218
#define YFm    213
#define WBm    38
#define YBm    41
#define WFM    254
#define YFM    249
#define WBM    1
#define YBM    6
#define SA     (l_count_1 + r_count_1)
#define R_SA     ((r_count_1 - r_cnt_old) + (l_count_1 - l_cnt_old) * 220 / 100)
#define T_SA    (r_count_1 + l_count_1 * 220 / 100)
/* define for New Mode */
#define Kx	0.01				/*the gain of location*/
#define Kv	0.05				/*the gain of speed*/
#define SAc	4				/*the difference in power between right motor and left one*/
#define SAx	(l_count_1 + r_count_1)				/*the remainder of total count*/
#define SAv	(l_count_v + r_count_v)				/*the remainder of this count*/
//#define SAxH	((x-intarval/2)*l_count_1 + (x+intarval/2)*r_count_1)/x				/*the remainder of total count*/
//#define SAvH	((x-intarval/2)*l_count_v + (x+intarval/2)*r_count_v)/x				/*the remainder of this count*/
#define GOAL	(x * gear * cpr /(diameter * pi))		/*number of locations to the target value*/
#define IGOAL	(x * gear * cpr * (han-VAL)/(diameter * 180))	
#define OGOAL	(x * gear * cpr * (han+VAL)/(diameter * 180))
#define HGOAL	(x * gear * cpr * VAL/(diameter * 180))		/*number of locations to the target value*/
#define Kgoal	10.0			/**/
#define FRmin 188		/*minimam duty raito in movin forward*/
#define RRmin 68				/*minimam duty raito in moving retreats*/
#define KIHON 230		/*the duty raito in turning*/
/* */
/* For the task control */
#define COMMAND_FIFO  5
#define START_TASK    1   
#define STOP_TASK     2  
#define RESTART_TASK  3  
#define TUNE_SET      4

/* For Rotary Encoder */
#define diameter   6.16  /* diameter of the tire [cm] */
#define pi         3.14
#define peri       0.02  /* execution period of RT-Task [sec] */
#define gear         16  /* gear ratio */
#define cpr         100  /* the number of counts a revolution */
#define intarval     25  /* the intarval between the tires */
#define VAL        12.5

/* For PWM-Set */
#define MODE_KEEP	-999
#define MODE_DUTY	123
#define MODE_STOP	456
#define MODE_RETURN	789
#define MODE_LR		147
#define MODE_STR	148
#define MODE_HANKEI 	149
#define MODE_BITYOUSEI  150

/* For PWM-Get */
#define MODE_COUNT	200
#define MODE_SUM	201
#define MODE_DUMMY	202

/* Define the I/O ports */
#define PWM_LEFT_WRITE   0x0110
#define PWM_RIGHT_WRITE  0x0112
#define LEFT_COUNTER     0x0120
#define RIGHT_COUNTER    0x0122

struct Message{
	int Command;     /* Command to control RT-task */
	int Task;        /* number of the RT-task */
	int Period;      /* execution period of the RT-task */
};
struct CountData{
	int LCount;        /* pulses of left counter */
	int RCount;       /* pulses of right counter */
	int LSum;    /* sum of puslses of left counter */
	int RSum;    /* sum of puslses of right counter */
	int br;
};
struct SpeedData{
	int LSpeed;     /* velocity of left wheel */
	int RSpeed;     /* velocity of right wheel */
	int Tup;
	int Mode;
};

#endif
